From 9ebb911583c863bea294fbc4c453eee54d134d3c Mon Sep 17 00:00:00 2001
From: Matthew Harmsen <mharmsen@pki.usersys.redhat.com>
Date: Tue, 16 Dec 2014 15:55:20 -0700
Subject: [PATCH] Update dependencies

- PKI TRAC Ticket #1187 - mod_perl should be removed from requirements for 10.2
- PKI TRAC Ticket #1205 - Outdated selinux-policy dependency.
- Removed perl(XML::LibXML), perl-Crypt-SSLeay, and perl-Mozilla-LDAP runtime
  dependencies
---
 specs/dogtag-pki.spec | 14 +++++++++++---
 specs/pki-core.spec   | 19 +++++++++++++------
 2 files changed, 24 insertions(+), 9 deletions(-)

diff --git a/specs/dogtag-pki.spec b/specs/dogtag-pki.spec
index afb2783..46adc34 100644
--- a/specs/dogtag-pki.spec
+++ b/specs/dogtag-pki.spec
@@ -1,7 +1,7 @@
 Summary:          Dogtag Public Key Infrastructure (PKI) Suite
 Name:             dogtag-pki
 Version:          10.2.1
-Release:          0.2%{?dist}
+Release:          0.4%{?dist}
 # The entire source code is GPLv2 except for 'pki-tps' which is LGPLv2
 License:          GPLv2 and LGPLv2
 URL:              http://pki.fedoraproject.org/
@@ -17,12 +17,17 @@ ExcludeArch:      ppc ppc64 ppcle ppc64le s390 s390x
 %define esc_version                1.1.0
 # NOTE:  The following package versions are TLS compliant:
 %define jss_version                4.2.6-35
-%define pki_core_version           %{version}-0.2
+%define pki_core_version           %{version}-0.4
 %define pki_console_version        %{version}-0.2
 %define tomcatjss_version          7.1.1
 
 Requires:         apache-commons-codec
-Requires:         selinux-policy-base >= 3.11.1-43
+%if  0%{?fedora} >= 21
+Requires:         selinux-policy-targeted >= 3.13.1-9
+%else
+# 0%{?rhel} || 0%{?fedora} < 21
+Requires:         selinux-policy-targeted >= 3.12.1-153
+%endif
 
 # Make certain that this 'meta' package requires the latest version(s)
 # of ALL top-level Dogtag PKI support packages
@@ -107,6 +112,9 @@ rm -rf %{buildroot}
 %doc README
 
 %changelog
+* Tue Dec 16 2014 Matthew Harmsen <mharmsen@redhat.com> - 10.2.1-0.4
+- PKI TRAC Ticket #1205 - Outdated selinux-policy dependency.
+
 * Mon Nov 24 2014 Christina Fu <cfu@redhat.com> 10.2.1-0.2
 - Ticket 1198 Bugzilla 1158410 add TLS range support to server.xml by default and upgrade (cfu)
 - Make dependencies comply with TLS changes (mharmsen)
diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index 82229a5..a45d1ee 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -5,7 +5,7 @@ distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
 
 Name:             pki-core
 Version:          10.2.1
-Release:          0.3%{?dist}
+Release:          0.4%{?dist}
 Summary:          Certificate System - PKI Core Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -312,15 +312,18 @@ Obsoletes:        pki-silent < %{version}-%{release}
 Requires:         java-headless >= 1:1.7.0
 Requires:         net-tools
 Requires:         perl(File::Slurp)
-Requires:         perl(XML::LibXML)
-Requires:         perl-Crypt-SSLeay
 Requires:         policycoreutils
 Requires:         openldap-clients
 Requires:         pki-base = %{version}-%{release}
 Requires:         pki-tools = %{version}-%{release}
 Requires:         policycoreutils-python
 
-Requires:         selinux-policy-base >= 3.11.1-43
+%if  0%{?fedora} >= 21
+Requires:         selinux-policy-targeted >= 3.13.1-9
+%else
+# 0%{?rhel} || 0%{?fedora} < 21
+Requires:         selinux-policy-targeted >= 3.12.1-153
+%endif
 Obsoletes:        pki-selinux
 
 %if 0%{?rhel}
@@ -504,12 +507,10 @@ Requires(postun): systemd-units
 # additional runtime requirements needed to run native 'tpsclient'
 # REMINDER:  Revisit these once 'tpsclient' is rewritten as a Java app
 Requires:         mod_nss
-Requires:         mod_perl
 Requires:         mod_revocator
 Requires:         nss >= 3.14.3
 Requires:         nss-tools >= 3.14.3
 Requires:         openldap-clients
-Requires:         perl-Mozilla-LDAP
 Requires:         pki-symkey = %{version}-%{release}
 
 %description -n   pki-tps
@@ -874,6 +875,12 @@ echo >> /var/log/pki/pki-server-upgrade-%{version}.log 2>&1
 %endif # %{with server}
 
 %changelog
+* Tue Dec 16 2014 Matthew Harmsen <mharmsen@redhat.com> - 10.2.1-0.4
+- PKI TRAC Ticket #1187 - mod_perl should be removed from requirements for 10.2
+- PKI TRAC Ticket #1205 - Outdated selinux-policy dependency.
+- Removed perl(XML::LibXML), perl-Crypt-SSLeay, and perl-Mozilla-LDAP runtime
+  dependencies
+
 * Fri Dec 12 2014 Ade Lee <alee@redhat.com> 10.2.1-0.3
 - Change resteasy dependencies for F22+
 
-- 
1.9.3